window.Gleam.initSearch([{"doc":"differance","title":"differance","content":"# differance\n\n[![Package Version](https://img.shields.io/hexpm/v/differance)](https://hex.pm/packages/differance)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/differance/)\n\nA difference list library for Gleam!\n\nA difference list (diff list or dlist for short) is a representation of a list \nthat allows for `snoc` and `append` operations in constant O(1) time.\n\nThe name of this package is an homage to the french philosopher Jaques Derrida\nand his concept of &quot;différance&quot; (also, the name dlist was already taken)\n\n## Instalation\n\nThis library can be added to your Gleam project by running:\n\n```sh\n$ gleam add differance\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/differance&gt;.\n","url":"index.html"},{"doc":"differance","title":"DList","content":"pub type DList(a) =\n  fn(List(a)) -&gt; List(a)\n A difference list is a way of representing a list that allows for the use \n of the &quot;snoc&quot; and &quot;append&quot; operations\n in constant O(1) time.\n\nSynonyms:\ndifferance.DList\ndifferance DList","url":"differance.html#DList"},{"doc":"differance","title":"append","content":"pub fn append(\n  first: fn(List(a)) -&gt; List(a),\n  with second: fn(List(a)) -&gt; List(a),\n) -&gt; fn(List(a)) -&gt; List(a)\n Get the diff that represents the concatenation of first and second\n\nSynonyms:\ndifferance.append\ndifferance append","url":"differance.html#append"},{"doc":"differance","title":"concat","content":"pub fn concat(\n  diffs: List(fn(List(a)) -&gt; List(a)),\n) -&gt; fn(List(a)) -&gt; List(a)\n Get a diff that represents the concatenation of all given diff\n\nSynonyms:\ndifferance.concat\ndifferance concat","url":"differance.html#concat"},{"doc":"differance","title":"empty","content":"pub fn empty() -&gt; fn(List(a)) -&gt; List(a)\n An empty difference list\n (DList, append, empty) is a monoid\n  \nSynonyms:\ndifferance.empty\ndifferance empty","url":"differance.html#empty"},{"doc":"differance","title":"fold","content":"pub fn fold(\n  over diff: fn(List(a)) -&gt; List(a),\n  from initial: b,\n  with f: fn(b, a) -&gt; b,\n) -&gt; b\n Reduce a diff into a single value by calling a given function\n on each element from left to right\n  \nSynonyms:\ndifferance.fold\ndifferance fold","url":"differance.html#fold"},{"doc":"differance","title":"fold_right","content":"pub fn fold_right(\n  over diff: fn(List(a)) -&gt; List(a),\n  from initial: b,\n  with f: fn(b, a) -&gt; b,\n) -&gt; b\n Reduce a diff into a single value by calling a given function\n on each element from right to left\n\nSynonyms:\ndifferance.fold_right\ndifferance fold_right","url":"differance.html#fold_right"},{"doc":"differance","title":"from_list","content":"pub fn from_list(list: List(a)) -&gt; fn(List(a)) -&gt; List(a)\n Creates a diff representing list\n\nSynonyms:\ndifferance.from_list\ndifferance from_list","url":"differance.html#from_list"},{"doc":"differance","title":"head","content":"pub fn head(of diff: fn(List(a)) -&gt; List(a)) -&gt; Option(a)\n Returns the first element of a diff wrapped in an option\n\nSynonyms:\ndifferance.head\ndifferance head","url":"differance.html#head"},{"doc":"differance","title":"length","content":"pub fn length(of diff: fn(List(a)) -&gt; List(a)) -&gt; Int\n Counts the number of elements in a given diff.\n\nSynonyms:\ndifferance.length\ndifferance length","url":"differance.html#length"},{"doc":"differance","title":"map","content":"pub fn map(\n  diff: fn(List(a)) -&gt; List(a),\n  with f: fn(a) -&gt; b,\n) -&gt; fn(List(b)) -&gt; List(b)\n Creates a new diff whose elements are the result of applying\n the given function to the elements of the original list\n \nSynonyms:\ndifferance.map\ndifferance map","url":"differance.html#map"},{"doc":"differance","title":"map2","content":"pub fn map2(\n  diff1: fn(List(a)) -&gt; List(a),\n  diff2: fn(List(b)) -&gt; List(b),\n  with f: fn(a, b) -&gt; c,\n) -&gt; fn(List(c)) -&gt; List(c)\n Combines two diffs into a single diff using the given function\n \n If a diff is longer than the other the extra elements are dropped\n\nSynonyms:\ndifferance.map2\ndifferance map2","url":"differance.html#map2"},{"doc":"differance","title":"reverse","content":"pub fn reverse(\n  diff: fn(List(a)) -&gt; List(a),\n) -&gt; fn(List(a)) -&gt; List(a)\n Creates a new diff from a given diff containing the same elements but\n in the opposite order.\n\nSynonyms:\ndifferance.reverse\ndifferance reverse","url":"differance.html#reverse"},{"doc":"differance","title":"singleton","content":"pub fn singleton(elem: a) -&gt; fn(List(a)) -&gt; List(a)\n A diff with a single element\n\nSynonyms:\ndifferance.singleton\ndifferance singleton","url":"differance.html#singleton"},{"doc":"differance","title":"tail","content":"pub fn tail(\n  of diff: fn(List(a)) -&gt; List(a),\n) -&gt; Option(fn(List(a)) -&gt; List(a))\n Returns a diff with the same elements excluding the first one\n wrapped in an Option\n \nSynonyms:\ndifferance.tail\ndifferance tail","url":"differance.html#tail"},{"doc":"differance","title":"to_list","content":"pub fn to_list(diff: fn(List(a)) -&gt; List(a)) -&gt; List(a)\n Collapses a diff into a list\n\nSynonyms:\ndifferance.to_list\ndifferance to_list","url":"differance.html#to_list"},{"doc":"differance","title":"zip","content":"pub fn zip(\n  diff: fn(List(a)) -&gt; List(a),\n  with other: fn(List(b)) -&gt; List(b),\n) -&gt; fn(List(#(a, b))) -&gt; List(#(a, b))\n Combines two diffs into a diff of tuples of their elements\n\n If a diff is longer than the other the extra elements are dropped\n\nSynonyms:\ndifferance.zip\ndifferance zip","url":"differance.html#zip"},{"doc":"differance","title":"differance","content":"","url":"differance.html"}]);